;;Copyright <2023> <Spaghetti Studios>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.


;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
;; Start of _DATA area 
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
.area _DATA
;; Start of _CODE area
.area _CODE

.globl cpct_disableFirmware_asm
.globl cpct_waitVSYNC_asm
.globl entityman_init
.globl shotsys_init
.globl rendersys_init
.globl collitionsys_init
.globl physicssys_init
.globl rendersys_update
.globl physicssys_update
.globl shotsys_update
.globl collitionsys_update
.globl entityman_create_din
.globl entityman_create_est
.globl entityman_getDinEntityArray_IX
.globl entityman_getNumDinEntities_A
.globl shotsys_getHayBomba_A
.globl collitionsys_getContadorDerribados_A
.globl collitionsys_getHeMuerto_A
.globl winsys_yes
.globl winsys_lose
.globl cpct_drawSprite_asm
.globl cpct_setVideoMode_asm
.globl cpct_setPalette_asm
.globl iniciar_menu
.globl _g_palette
.globl correr_menu
.globl man_controls_exit
.globl man_controls_init
.globl MENU_CARGA
.globl menu_getEntrar_A

init_main::
   ancho_edf == 3 ;;bomba tamb de esta anchura 

   ; definicion de entidades dinamicas:     avion, bomba                                                          
   ;           pos x, pos y, ancho (de 4 en 4), alto, velocidad x (de 4 en 4), color ||(sprite) 
   avion:  .db  0,    40,    6,                 10,   2,                       0x0F   
   bomba:  .db  0,     0,    3,                 12,   4,                       0x0F    ;;poner posicion en el momento d lanzarla  

   ; definicion de entidades estaticas:     edificios (10?), suelo
   ;           pos x, pos y, ancho (de 4 en 4), alto, color ||(sprite)
   suelo:  .db  0,    185,   64,                15,   0xF0 ;ancho maximo es 64, pantalla entera es 79
   suelo2: .db 64,    185,   16,                15,   0xF0 ;ancho maximo es 64, pantalla entera es 79

   edf1:   .db 27,    135,   ancho_edf,         50,   0xc0 
   edf2:   .db 30,    107,   ancho_edf,         78,   0xc0 
   edf3:   .db 33,    123,   ancho_edf,         62,   0xc0 
   edf4:   .db 36,    127,   ancho_edf,         58,   0xc0 
   edf5:   .db 39,    100,   ancho_edf,         85,   0xc0 
   edf6:   .db 42,    110,   ancho_edf,         75,   0xc0 
   edf7:   .db 45,    135,   ancho_edf,         50,   0xc0
ret

_main::
   call cpct_disableFirmware_asm

   ;============================================================================================================
   ;  INIT SYSTEMS PT 1 (pre creacion entidades)
   ;============================================================================================================
   ;JUEGO::
   MENU::
   call MENU_CARGA

   JUEGO::
   

   call init_main
   call entityman_init
   call shotsys_init
   call collitionsys_init
   call physicssys_init
   ;call rendersys_init

   ;;COMPROBAR PARA ENTRAR-------------------------------------------------------------------------------------
   ;call menu_getEntrar_A
   ;cp #1
   ;ret nz

   ;============================================================================================================
   ;  CREAR ENTIDADES
   ;============================================================================================================
   ; DINAMICAS---------------------------------
   ld hl, #avion
   call entityman_create_din
   ld hl, #bomba
   call entityman_create_din

   ; ESTATICAS --------------------------------
   ld hl, #suelo
   call entityman_create_est
   ld hl, #suelo2
   call entityman_create_est

   ld hl, #edf1 
   call entityman_create_est
   ld hl, #edf2 
   call entityman_create_est
   ld hl, #edf3 
   call entityman_create_est
   ld hl, #edf4 
   call entityman_create_est
   ld hl, #edf5 
   call entityman_create_est
   ld hl, #edf6 
   call entityman_create_est
   ld hl, #edf7 
   call entityman_create_est

   ;============================================================================================================
   ;  INIT SYSTEMS PT2 (post creacion entidades)
   ;============================================================================================================
   call rendersys_init

   ;===============================================================================================================
   ;  BUCLE PRINCIPAL
   loop: ;=========================================================================================================
      call collitionsys_getHeMuerto_A
      cp #1
      jr nz, no_lose 
         call winsys_lose
         ;ret
      no_lose:
      
      call collitionsys_getContadorDerribados_A
      cp #7
      jr nz, no_win 
         call winsys_yes
         ;ret
      no_win:

      call entityman_getDinEntityArray_IX
      call entityman_getNumDinEntities_A

      call physicssys_update
      call shotsys_update
      call rendersys_update
      call collitionsys_update

      ;esperar
      .rept 5
         halt 
         halt
         call cpct_waitVSYNC_asm
      .endm

   jr    loop

   ret