;;Copyright <2023> <Spaghetti Studios>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.

.include "cpctelera.h.s"

.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm
.globl cpct_isAnyKeyPressed_f_asm
.globl cpct_setVideoMemoryOffset_asm
.globl cpct_zx7b_decrunch_s_asm
.globl man_controls_init
.globl man_controls_exit
.globl _controles_end
.globl _pantalla_final_ganar_z_end
;; Inicializamos el menu con la imagen de fondo con los controles

man_controls_init::

    ld   l, #0
    call cpct_setVideoMemoryOffset_asm  ;;cambiamos el offset de la memoria (donde empieza lo que se ve)

    ld  hl, #_controles_end
    ld  de, #0xFFFF 
    call cpct_zx7b_decrunch_s_asm
ret

man_controls_exit::
    ;; Seguiremos en esta pantalla mientras las teclas pulsadas no sean ESC o 3 para salir y volver al menu 
    call cpct_scanKeyboard_asm

    ld  hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr  nz, exit

    ld  hl, #Key_3
    call cpct_isKeyPressed_asm
    jr  nz, exit

    call  cpct_isAnyKeyPressed_f_asm
    jr z, man_controls_exit  

    exit: 
ret