;;Copyright <2023> <Spaghetti Studios>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.
;;
;; ENTITY MANAGER
;
;   LISTA ENTIDADES:                        SEPARAR EN 2 ARRAYS:
;       -avion                                  -ent dinamicas (player 
;       -bomba                                  -end estaticas (suelo y barreras)
;       -suelo (x2)                         
;       -edificios
;              
;; VARIABLES ==============================================================

numero_array: .db 0

max_din_entities == 2 
din_entity_size  == 6

max_est_entities == 10 ; AUMENTAR EN EL FUTURO
est_entity_size  == 5

_num_din_entities: .db 0 ;porque aún no se han creado
_num_est_entities: .db 0 ;porque aún no se han creado

_din_entity_array:  
    .ds max_din_entities*din_entity_size 

_est_entity_array:  
    .ds max_est_entities*est_entity_size 

_last_din_elem_ptr: .dw _din_entity_array ; puntero al último elemento del array
_last_est_elem_ptr: .dw _est_entity_array ; puntero al último elemento del array

entityman_init:: ; resetear todos los valores
    
    xor a ; poner A a 0
    ld (_num_din_entities), a ;num entidades -> 0
    ld (_num_est_entities), a ;num entidades -> 0

    ld hl, #_din_entity_array
    ld (_last_din_elem_ptr), hl

    ld hl, #_est_entity_array
    ld (_last_est_elem_ptr), hl

    ret

;;ENTRADA: 
;;      HL: puntero a entity initializer bytes
entityman_create_din:: ;crea una entidad en el array de ent dinamicas
    ld de, (_last_din_elem_ptr)
    ld bc, #din_entity_size
    ldir

    ld a, (_num_din_entities)
    inc a
    ld (_num_din_entities), a

    ld hl, (_last_din_elem_ptr)
    ld bc, #din_entity_size
    add hl, bc
    ld (_last_din_elem_ptr), hl

    ret

entityman_create_est:: ;crea una entidad en el array de ent estaticas
    ld de, (_last_est_elem_ptr)
    ld bc, #est_entity_size
    ldir

    ld a, (_num_est_entities)
    inc a
    ld (_num_est_entities), a

    ld hl, (_last_est_elem_ptr)
    ld bc, #est_entity_size
    add hl, bc
    ld (_last_est_elem_ptr), hl

    ret

entityman_getDinEntityArray_IX::
    ld ix, #_din_entity_array
    ret

entityman_getNumDinEntities_A::
    ld a, (_num_din_entities)
    ret

entityman_getDinEntitySize_BC::
    ld bc, #din_entity_size
    ret

; devolver variables de ent estaticas -------------------------------

entityman_getEstEntityArray_IX::
    ld ix, #_est_entity_array
    ret

entityman_getNumEstEntities_A::
    ld a, (_num_est_entities)
    ret

entityman_getEstEntitySize_BC::
    ld bc, #est_entity_size
    ret