;;Copyright <2023> <Spaghetti Studios>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.

;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.area _DATA
.area _CODE

.globl cpct_disableFirmware_asm
.globl cpct_waitVSYNC_asm
.globl entityman_init
.globl rendersys_update
.globl physicssys_update
.globl shotsys_update
.globl collitionsys_update
.globl entityman_create_din
.globl entityman_create_est
.globl entityman_getDinEntityArray_IX
.globl entityman_getNumDinEntities_A
.globl cpct_drawSprite_asm
.globl cpct_setVideoMode_asm
.globl cpct_setPalette_asm
.globl iniciar_menu
.globl _g_palette
.globl correr_menu
.globl man_controls_exit
.globl man_controls_init
.globl eleccion_menu
.globl JUEGO

eleccion_menu: .db 0
_entrar: .db 1

menu_getEntrar_A::
    ld a, (_entrar)
    ret

MENU_CARGA::
   call cpct_disableFirmware_asm

   ld  c, #0
   call cpct_setVideoMode_asm
   ld  hl, #_g_palette   ;; siempre con _ las variables de C
   ld  de, #16                ;; tiene 16 colores la paleta de mi sprite
   call cpct_setPalette_asm

   call iniciar_menu
   ;===============================================================================================================
   ;  BUCLE 
   loop: ;=========================================================================================================
   call correr_menu  
   
   ;; Comprobamos que opcion se ha elegido
   ld a, (eleccion_menu)
   sub #1
   jr z, game_play

   ;; Restamos si el resultado que queda en A es 0 entramos
   ld a, (eleccion_menu)
   sub #2
   jr z, game_controls

   ld a, (eleccion_menu)
   sub #3
   jr z, continue

   jr continue

   game_play::
      ;; Primero limpiamos la pantalla para luego iniciar el game
      call JUEGO
      jr continue
   
   game_controls:
      ;; Primero limpiamos pantallo y luego iniciamos la pantalla de controles
      call clear_screen
      call man_controls_init
      ;; Se queda esperando hasta que se pulse el 3 o el ESC
      call man_controls_exit
      jr continue


  ; game_exit:
  ;      ld a, #0
  ;      ld (_entrar), a
  ;  ret
          
   continue:
      ;; Si llega aqui es ha vuelto al menu principal y lo volvemos a pintar
      call clear_screen 
      call iniciar_menu

   call cpct_waitVSYNC_asm

   jr    loop

clear_screen:

   ;; Limpiamos la pantalla
   cpctm_clearScreen_asm 0x00


ret

