;;Copyright <2023> <Spaghetti Studios>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.
;
; SISTEMA DE COLISIONES

.include "cpctelera.h.s"
.include "collition-system.h.s"

.globl entityman_getEstEntityArray_IX
.globl entityman_getDinEntityArray_IX
.globl entityman_getNumEstEntities_A
.globl entityman_getEstEntitySize_BC
.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl shotsys_getHayBomba_A
.globl shotsys_setHayBomba_0
.globl rendersys_borrar_ult_bomba

_contador_derribados: .db 0
_he_muerto: .db 0

collitionsys_init::
    _pos_bomb_x: .db 0
    _pos_bomb_y: .dw 0

    _pos_avion_x: .db 0
    _pos_avion_y: .dw 0
    _ancho_avion: .db 0
    _alto_avion:  .db 0

    xor a
    ld (_contador_derribados), a

    xor a
    ld (_he_muerto), a
ret

collitionsys_getContadorDerribados_A::
    ld a, (_contador_derribados)
ret

collitionsys_getHeMuerto_A::
    ld a, (_he_muerto)
ret

collitionsys_update::
    call collitionsys_avion_edf
    call shotsys_getHayBomba_A
    ; comprobar si es 1 o 0
    cp #1 ;;resta 1 a A
    ret nz  ;nz -> CONDICION PARA IRSE
        call collitionsys_bomba_suelo
        call collitionsys_bomba_edf
ret

collitionsys_bomba_suelo:
    ld a, bomb_y(ix)
    add a, #12 ;;alto d la bomba
    add a, #(256-185)
    ret nc  
        call shotsys_setHayBomba_0      ;;matar a la bomba
        call rendersys_borrar_ult_bomba ;;borrar la bomba
        ;ld e_col(ix), #0x0F
ret

collitionsys_bomba_edf:
    ld a, bomb_y(ix)
    ld (_pos_bomb_y), a

    ld a, bomb_x(ix)
    ld (_pos_bomb_x), a

    ;;comprobar si estoy en el rango de edificios (posx_edf1, posx_ultEdf+ancho_Edf)
    call entityman_getEstEntityArray_IX
    add a, #(256-25)    ;posx primer edf + posx bomba || 27-ANCHOBMB+1 para q impacte al primer edificio si esta mas a la izda
    ret nc ;;salimos si la bomba esta mas a la izda
        ld a, (_pos_bomb_x)
        add a, #(256-47)    ;posx ult edf + ancho edf - 1
        ret c  ;;salimos si la bomba esta mas a la derecha
            ;;aqui estamos en el rango correcto
            ;;CASO 1: hay un edf directamente debajo de la bomba
            ld a, (_pos_bomb_x)         
            cp edf_x(ix)
            jr nz, edf2   
                edf1:           
                ;ld 4(ix), #0xFF ;pintar el suelo de rojo ***********
                ld a, #256
                ld b, edf_y(ix)
                sub b
                ld b, a
                ld a, (_pos_bomb_y)
                add a, #12
                add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                ret nc
                    ;;cosas color vvvvv
                    ld b, edf_col(ix)
                    xor a
                    add a, b
                    ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                        ld edf_col(ix), #0x00           ;;borrar el edificio

                        ld de, #0xC000
                        ld c, edf_x(ix) 
                        ld b, edf_y(ix) 
                        call cpct_getScreenPtr_asm
                        ex de, hl
                        ld a, #0x00      ;color del fondo   
                        ld c, edf_w(ix)    ;width
                        ld b, edf_h(ix)    ;height
                        call cpct_drawSolidBox_asm
                    ;;cosas color ^^^^^
                        
                        ld a, (_contador_derribados)
                        inc a
                        ld (_contador_derribados), a    ;;aumentar num de edificios matados
                        call matar_bomba
                        ret
            edf2:
            ld a, (_pos_bomb_x)         
            cp edf_x_2(ix) 
            jr nz, edf3
                ;ld 4(ix), #0xFF ;pintar el suelo de rojo ***********
                ld a, #256
                ld b, edf_y_2(ix)
                sub b
                ld b, a
                ld a, (_pos_bomb_y)
                add a, #12
                add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                ret nc
                ;;cosas color vvvvv
                    ld b, edf_col_2(ix)
                    xor a
                    add a, b
                    ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                        ld edf_col_2(ix), #0x00           ;;borrar el edificio

                        ld de, #0xC000
                        ld c, edf_x_2(ix) 
                        ld b, edf_y_2(ix) 
                        call cpct_getScreenPtr_asm
                        ex de, hl
                        ld a, #0x00      ;color del fondo   
                        ld c, edf_w_2(ix)    ;width
                        ld b, edf_h_2(ix)    ;height
                        call cpct_drawSolidBox_asm
                    ;;cosas color ^^^^^
                    ld a, (_contador_derribados)
                   inc a
                    ld (_contador_derribados), a    ;;aumentar num de edificios matados
                    call matar_bomba
                    ret
            edf3:
            ld a, (_pos_bomb_x)         
            cp edf_x_3(ix)
            jr nz, edf4
                edf3_inexacto:
                ;ld 4(ix), #0xFF ;pintar el suelo de rojo ***********
                ld a, #256
                ld b, edf_y_3(ix)
                sub b
                ld b, a
                ld a, (_pos_bomb_y)
                add a, #12
                add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                ret nc
                    ;;cosas color vvvvv
                    ld b, edf_col_3(ix)
                    xor a
                    add a, b
                    ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                        ld edf_col_3(ix), #0x00           ;;borrar el edificio

                        ld de, #0xC000
                        ld c, edf_x_3(ix) 
                        ld b, edf_y_3(ix) 
                        call cpct_getScreenPtr_asm
                        ex de, hl
                        ld a, #0x00      ;color del fondo   
                        ld c, edf_w_3(ix)    ;width
                        ld b, edf_h_3(ix)    ;height
                        call cpct_drawSolidBox_asm
                    ;;cosas color ^^^^^
                    ld a, (_contador_derribados)
                   inc a
                    ld (_contador_derribados), a    ;;aumentar num de edificios matados
                    call matar_bomba
                    ret
            edf4:
            ld a, (_pos_bomb_x)         
            cp edf_x_4(ix)
            jr nz, edf5
                edf4_inexacto:
                ;ld 4(ix), #0xFF ;pintar el suelo de rojo ***********
                ld a, #256
                ld b, edf_y_4(ix)
                sub b
                ld b, a
                ld a, (_pos_bomb_y)
                add a, #12
                add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                ret nc
                    ;;cosas color vvvvv
                    ld b, edf_col_4(ix)
                    xor a
                    add a, b
                    ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                        ld edf_col_4(ix), #0x00           ;;borrar el edificio

                        ld de, #0xC000
                        ld c, edf_x_4(ix) 
                        ld b, edf_y_4(ix) 
                        call cpct_getScreenPtr_asm
                        ex de, hl
                        ld a, #0x00      ;color del fondo   
                        ld c, edf_w_4(ix)    ;width
                        ld b, edf_h_4(ix)    ;height
                        call cpct_drawSolidBox_asm
                    ;;cosas color ^^^^^
                    ld a, (_contador_derribados)
                   inc a
                    ld (_contador_derribados), a    ;;aumentar num de edificios matados
                    call matar_bomba
                    ret
            edf5:
            ld a, (_pos_bomb_x)         
            cp edf_x_5(ix)
            jr nz, edf6
                ;ld 4(ix), #0xFF ;pintar el suelo de rojo ***********
                ld a, #256
                ld b, edf_y_5(ix)
                sub b
                ld b, a
                ld a, (_pos_bomb_y)
                add a, #12
                add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                ret nc
                    ;;cosas color vvvvv
                    ld b, edf_col_5(ix)
                    xor a
                    add a, b
                    ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                        ld edf_col_5(ix), #0x00           ;;borrar el edificio

                        ld de, #0xC000
                        ld c, edf_x_5(ix) 
                        ld b, edf_y_5(ix) 
                        call cpct_getScreenPtr_asm
                        ex de, hl
                        ld a, #0x00      ;color del fondo   
                        ld c, edf_w_5(ix)    ;width
                        ld b, edf_h_5(ix)    ;height
                        call cpct_drawSolidBox_asm
                    ;;cosas color ^^^^^
                    ld a, (_contador_derribados)
                   inc a
                    ld (_contador_derribados), a    ;;aumentar num de edificios matados
                    call matar_bomba
                    ret
            edf6:
            ld a, (_pos_bomb_x)         
            cp edf_x_6(ix)
            jr nz, edf7
                ;ld 4(ix), #0xFF ;pintar el suelo de rojo ***********
                edf6_inexacto:
                ld a, #256
                ld b, edf_y_6(ix)
                sub b
                ld b, a
                ld a, (_pos_bomb_y)
                add a, #12
                add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                ret nc
                    ;;cosas color vvvvv
                    ld b, edf_col_6(ix)
                    xor a
                    add a, b
                    ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                        ld edf_col_6(ix), #0x00           ;;borrar el edificio

                        ld de, #0xC000
                        ld c, edf_x_6(ix) 
                        ld b, edf_y_6(ix) 
                        call cpct_getScreenPtr_asm
                        ex de, hl
                        ld a, #0x00      ;color del fondo   
                        ld c, edf_w_6(ix)    ;width
                        ld b, edf_h_6(ix)    ;height
                        call cpct_drawSolidBox_asm
                    ;;cosas color ^^^^^
                    ld a, (_contador_derribados)
                   inc a
                    ld (_contador_derribados), a    ;;aumentar num de edificios matados
                    call matar_bomba
                    ret
            edf7:
            ld a, (_pos_bomb_x)         
            cp edf_x_7(ix)
            jr nz, _out_
            edf7_inexacto:
                ;ld 4(ix), #0xFF ;pintar el suelo de rojo ***********
                ld a, #256
                ld b, edf_y_7(ix)
                sub b
                ld b, a
                ld a, (_pos_bomb_y)
                add a, #12
                add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                ret nc
                    ;;cosas color vvvvv
                    ld b, edf_col_7(ix)
                    xor a
                    add a, b
                    ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                        ld edf_col_7(ix), #0x00           ;;borrar el edificio

                        ld de, #0xC000
                        ld c, edf_x_7(ix) 
                        ld b, edf_y_7(ix) 
                        call cpct_getScreenPtr_asm
                        ex de, hl
                        ld a, #0x00      ;color del fondo   
                        ld c, edf_w_7(ix)    ;width
                        ld b, edf_h_7(ix)    ;height
                        call cpct_drawSolidBox_asm
                    ;;cosas color ^^^^^
                    ld a, (_contador_derribados)
                   inc a
                    ld (_contador_derribados), a    ;;aumentar num de edificios matados
                    call matar_bomba
                    ret

            _out_:;=============================================================================================================
                ;;;CASO 2: hay DOS edfs debajo de la bomba (esta en medio)   ===================================================
                ;; =============================================================================================================

                ;0-endf1 = pos 25, 26 ;*************************************************************************************
                ld a, (_pos_bomb_x)         
                cp #25              
                jr nz, sig      
                    col_edf1:
                    ;estoy en la 25, tirar el edf1
                    ld a, #256
                    ld b, edf_y(ix)
                    sub b
                    ld b, a
                    ld a, (_pos_bomb_y)
                    add a, #12
                    add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                    ret nc
                        ;;cosas color vvvvv
                        ld b, edf_col(ix)
                        xor a
                        add a, b
                        ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                            ld edf_col(ix), #0x00           ;;borrar el edificio

                            ld de, #0xC000
                            ld c, edf_x(ix) 
                            ld b, edf_y(ix) 
                            call cpct_getScreenPtr_asm
                            ex de, hl
                            ld a, #0x00      ;color del fondo   
                            ld c, edf_w(ix)    ;width
                            ld b, edf_h(ix)    ;height
                            call cpct_drawSolidBox_asm
                        ;;cosas color ^^^^^
                        ld a, (_contador_derribados)
                        inc a
                        ld (_contador_derribados), a    ;;aumentar num de edificios matados
                        call matar_bomba
                        ret
                sig:
                ld a, (_pos_bomb_x)         
                cp #26
                jr nz, ed1_2
                    ;estoy en la 26
                    call col_edf1

                ed1_2:  ;*************************************************************************************************
                ;end1-edf2 = pos 28, 29
                ld a, (_pos_bomb_x)         
                cp #28
                jr nz, sig2
                    col_edf2:
                    ;estoy en la 28, tirar el edf2
                    ld a, #256
                    ld b, edf_y_2(ix)
                    sub b
                    ld b, a
                    ld a, (_pos_bomb_y)
                    add a, #12
                    add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                    ret nc
                        ;ld 4(ix), #0xFF
                        ;;cosas color vvvvv
                        ld b, edf_col_2(ix)
                        xor a
                        add a, b
                        jr z, matar_edf1 ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                            ld edf_col_2(ix), #0x00           ;;borrar el edificio
                            
                            ld de, #0xC000
                            ld c, edf_x_2(ix) 
                            ld b, edf_y_2(ix) 
                            call cpct_getScreenPtr_asm
                            ex de, hl
                            ld a, #0x00      ;color del fondo   
                            ld c, edf_w_2(ix)    ;width
                            ld b, edf_h_2(ix)    ;height
                            call cpct_drawSolidBox_asm
                            ;;cosas color ^^^^^
                            ld a, (_contador_derribados)
                            inc a
                            ld (_contador_derribados), a    ;;aumentar num de edificios matados
                            call matar_bomba
                            ret
                        matar_edf1:
                            call edf1          
                        ret
                sig2:
                ld a, (_pos_bomb_x)         
                cp #29
                jr nz, ed2_3
                    call col_edf2
                    
                ed2_3:   ;*************************************************************************************************
                ;end2-edf3 = pos 31, 32
                ld a, (_pos_bomb_x)         
                cp #31
                jr nz, sig3
                col_2_3:
                    ld a, #256
                    ld b, edf_y_2(ix)
                    sub b
                    ld b, a
                    ld a, (_pos_bomb_y)
                    add a, #12
                    add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                    ret nc
                        ;ld 4(ix), #0xFF
                        ;;cosas color vvvvv
                        ld b, edf_col_2(ix)
                        xor a
                        add a, b
                        jr z, matar_edf3 ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                            ld edf_col_2(ix), #0x00           ;;borrar el edificio

                            ld de, #0xC000
                            ld c, edf_x_2(ix) 
                            ld b, edf_y_2(ix) 
                            call cpct_getScreenPtr_asm
                            ex de, hl
                            ld a, #0x00      ;color del fondo   
                            ld c, edf_w_2(ix)    ;width
                            ld b, edf_h_2(ix)    ;height
                            call cpct_drawSolidBox_asm
                            ;;cosas color ^^^^^
                            ld a, (_contador_derribados)
                            inc a
                            ld (_contador_derribados), a    ;;aumentar num de edificios matados
                            call matar_bomba
                            ret
                        matar_edf3:
                            call edf3_inexacto          
                        ret
                sig3:
                ld a, (_pos_bomb_x)         
                cp #32
                jr nz, ed3_4
                    ;estoy en la 32
                    call col_2_3

                ed3_4:  ;*************************************************************************************************
                ;end3-edf4 = pos 34, 35
                ld a, (_pos_bomb_x)         
                cp #34
                jr nz, sig4
                    col_edf3:
                    ;estoy en la 34, tirar el edf3
                    ld a, #256
                    ld b, edf_y_3(ix)
                    sub b
                    ld b, a
                    ld a, (_pos_bomb_y)
                    add a, #12
                    add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                    ret nc
                        ;;cosas color vvvvv
                        ld b, edf_col_3(ix)
                        xor a
                        add a, b
                        jr z, matar_edf4 ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                            ld edf_col_3(ix), #0x00           ;;borrar el edificio

                            ld de, #0xC000
                            ld c, edf_x_3(ix) 
                            ld b, edf_y_3(ix) 
                            call cpct_getScreenPtr_asm
                            ex de, hl
                            ld a, #0x00      ;color del fondo   
                            ld c, edf_w_3(ix)    ;width
                            ld b, edf_h_3(ix)    ;height
                            call cpct_drawSolidBox_asm
                        ;;cosas color ^^^^^
                        ld a, (_contador_derribados)
                        inc a
                        ld (_contador_derribados), a    ;;aumentar num de edificios matados
                        call matar_bomba
                        ret
                    matar_edf4:
                        call edf4_inexacto
                    ret

                sig4:
                ld a, (_pos_bomb_x)         
                cp #35
                jr nz, ed4_5
                    ;estoy en la 35
                    call col_edf3

                ed4_5: ;************************************************************************************************
                ;end4-edf5 = pos 37, 38
                ld a, (_pos_bomb_x)         
                cp #37
                jr nz, sig5
                    ;estoy en la 37, tirar el edf5
                    col_edf5:
                    ld a, #256
                    ld b, edf_y_5(ix)
                    sub b
                    ld b, a
                    ld a, (_pos_bomb_y)
                    add a, #12
                    add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                    ret nc
                        ;;cosas color vvvvv
                        ld b, edf_col_5(ix)
                        xor a
                        add a, b
                        jr z, matar_edf4 ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                            ld edf_col_5(ix), #0x00           ;;borrar el edificio

                            ld de, #0xC000
                            ld c, edf_x_5(ix) 
                            ld b, edf_y_5(ix) 
                            call cpct_getScreenPtr_asm
                            ex de, hl
                            ld a, #0x00      ;color del fondo   
                            ld c, edf_w_5(ix)    ;width
                            ld b, edf_h_5(ix)    ;height
                            call cpct_drawSolidBox_asm
                        ;;cosas color ^^^^^
                        ld a, (_contador_derribados)
                        inc a
                        ld (_contador_derribados), a    ;;aumentar num de edificios matados
                        call matar_bomba
                        ret
                sig5:
                ld a, (_pos_bomb_x)         
                cp #38
                jr nz, ed5_6
                    ;estoy en la 38
                    call col_edf5

                ed5_6: ;************************************************************************************************
                ;end5-edf6 = pos 40, 41
                ld a, (_pos_bomb_x)         
                cp #40
                jr nz, sig6
                    col_5_6:
                    ld a, #256
                    ld b, edf_y_5(ix)
                    sub b
                    ld b, a
                    ld a, (_pos_bomb_y)
                    add a, #12
                    add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                    ret nc
                        ;;cosas color vvvvv
                        ld b, edf_col_5(ix)
                        xor a
                        add a, b
                        jr z, matar_edf6 ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                            ld edf_col_5(ix), #0x00           ;;borrar el edificio

                            ld de, #0xC000
                            ld c, edf_x_5(ix) 
                            ld b, edf_y_5(ix) 
                            call cpct_getScreenPtr_asm
                            ex de, hl
                            ld a, #0x00      ;color del fondo   
                            ld c, edf_w_5(ix)    ;width
                            ld b, edf_h_5(ix)    ;height
                            call cpct_drawSolidBox_asm
                        ;;cosas color ^^^^^
                        ld a, (_contador_derribados)
                        inc a
                        ld (_contador_derribados), a    ;;aumentar num de edificios matados
                        call matar_bomba
                        ret
                    matar_edf6:
                        call edf6_inexacto
                    ret
                sig6:
                ld a, (_pos_bomb_x)         
                cp #41
                jr nz, ed6_7
                    ;estoy en la 41
                    call col_5_6

                ed6_7: ;************************************************************************************************
                ;end6-edf7 = pos 43, 44
                ld a, (_pos_bomb_x)         
                cp #43
                jr nz, sig7
                    ;estoy en la 43, tirar el edf6
                    col_edf6:
                    ld a, #256
                    ld b, edf_y_6(ix)
                    sub b
                    ld b, a
                    ld a, (_pos_bomb_y)
                    add a, #12
                    add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                    ret nc
                        ;;cosas color vvvvv
                        ld b, edf_col_6(ix)
                        xor a
                        add a, b
                        jr z, matar_edf7 ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                            ld edf_col_6(ix), #0x00           ;;borrar el edificio

                            ld de, #0xC000
                            ld c, edf_x_6(ix) 
                            ld b, edf_y_6(ix) 
                            call cpct_getScreenPtr_asm
                            ex de, hl
                            ld a, #0x00      ;color del fondo   
                            ld c, edf_w_6(ix)    ;width
                            ld b, edf_h_6(ix)    ;height
                            call cpct_drawSolidBox_asm
                        ;;cosas color ^^^^^
                        ld a, (_contador_derribados)
                        inc a
                        ld (_contador_derribados), a    ;;aumentar num de edificios matados
                        call matar_bomba
                        ret
                    matar_edf7:
                        call edf7_inexacto
                    ret
                sig7:
                ld a, (_pos_bomb_x)         
                cp #44
                jr nz, ed7_0
                    ;estoy en la 44
                    call col_edf6

                ed7_0: ;************************************************************************************************
                ;end7-0 = pos 46, 47
                ld a, (_pos_bomb_x)         
                cp #46
                jr nz, sig8
                    ;estoy en la 43, tirar el edf6
                    col_edf7:
                    ld a, #256
                    ld b, edf_y_7(ix)
                    sub b
                    ld b, a
                    ld a, (_pos_bomb_y)
                    add a, #12
                    add a, b ;; (pos bomba + alt bomba) + (256-posY edf)
                    ret nc
                        ;;cosas color vvvvv
                        ld b, edf_col_7(ix)
                        xor a
                        add a, b
                        ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo
                            ld edf_col_7(ix), #0x00           ;;borrar el edificio

                            ld de, #0xC000
                            ld c, edf_x_7(ix) 
                            ld b, edf_y_7(ix) 
                            call cpct_getScreenPtr_asm
                            ex de, hl
                            ld a, #0x00      ;color del fondo   
                            ld c, edf_w_7(ix)    ;width
                            ld b, edf_h_7(ix)    ;height
                            call cpct_drawSolidBox_asm
                        ;;cosas color ^^^^^
                        ld a, (_contador_derribados)
                        inc a
                        ld (_contador_derribados), a    ;;aumentar num de edificios matados
                        call matar_bomba
                        ret
                sig8:
                ld a, (_pos_bomb_x)         
                cp #47
                jr nz, salir
                    ;estoy en la 44
                    call col_edf7

                salir:

ret

collitionsys_avion_edf:
    ;;coger pos avion
    ld a, e_din_y(ix)
    ld (_pos_avion_y), a

    ld a, e_din_x(ix)
    ld (_pos_avion_x), a

    ld a, e_w(ix)
    ld (_ancho_avion), a

    ld a, e_h(ix)
    ld (_alto_avion), a

    call entityman_getEstEntityArray_IX
    ;;comprobar posiciones x una a una
    ; *********************************************************************************************************************
    ld a, (_pos_avion_x)         
    cp #21 
    jr nz, int2  ;choque primer edf
        ;comprobar pos y
        chq_edf1:
        ld a, (_pos_avion_y)
        add a, #(256-125)   ;posY primer edf - alt avion (135-10)
        jr nc, crash2
            ;;hay choque
            ;;cosas color vvvvv
                ld b, edf_col(ix)
                xor a
                add a, b
                ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q chocarse
                    ld 4(ix), #0xFF
                    ;;GAME OVER
                    ld a, #1
                    ld (_he_muerto), a
            ;;cosas color ^^^^^
            ret
    int2:
    ld a, (_pos_avion_x)         
    cp #22
    jr nz, crash2  ;choque primer edf
        call chq_edf1

    crash2: ; *********************************************************************************************************************
    ld a, (_pos_avion_x)         
    cp #24 
    jr nz, int2_2  ;choque edf 2
        ;comprobar pos y
        chq_edf2:
        ld a, (_pos_avion_y)
        add a, #(256-97)   ;256 - (posY edf - alt avion) 
        jr nc, crash3
            ;;hay choque
            ;;cosas color vvvvv
                ld b, edf_col_2(ix)
                xor a
                add a, b
                ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q chocarse
                    ld 4(ix), #0xFF
                    ;;GAME OVER
                    ld a, #1
                    ld (_he_muerto), a
            ;;cosas color ^^^^^
            ret
    int2_2:
    ld a, (_pos_avion_x)         
    cp #25
    jr nz, crash3  ;choque edf2
        call chq_edf2

    crash3: ; *********************************************************************************************************************
    ld a, (_pos_avion_x)         
    cp #27 
    jr nz, int2_3  ;choque edf 3
        ;comprobar pos y
        chq_edf3:
        ld a, (_pos_avion_y)
        add a, #(256-113)   ;256 - (posY edf - alt avion) 
        jr nc, crash4
            ;;hay choque
            ;;cosas color vvvvv
                ld b, edf_col_3(ix)
                xor a
                add a, b
                ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q chocarse
                    ld 4(ix), #0xFF
                    ;;GAME OVER
                    ld a, #1
                    ld (_he_muerto), a
            ;;cosas color ^^^^^
            ret
    int2_3:
    ld a, (_pos_avion_x)         
    cp #28
    jr nz, crash4  ;choque edf3
        call chq_edf3

    crash4: ; *********************************************************************************************************************
    ld a, (_pos_avion_x)         
    cp #30 
    jr nz, int2_4  
        chq_edf4:
        ld a, (_pos_avion_y)
        add a, #(256-117)   ;256 - (posY edf - alt avion) 
        jr nc, crash5
            ;;cosas color vvvvv
                ld b, edf_col_4(ix)
                xor a
                add a, b
                ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q chocarse
                    ld 4(ix), #0xFF
                    ;;GAME OVER
                    ld a, #1
                    ld (_he_muerto), a
            ;;cosas color ^^^^^
            ret
    int2_4:
    ld a, (_pos_avion_x)         
    cp #31
    jr nz, crash5  
        call chq_edf4

    crash5: ; *********************************************************************************************************************
    ld a, (_pos_avion_x)         
    cp #33 
    jr nz, int2_5  
        chq_edf5:
        ld a, (_pos_avion_y)
        add a, #(256-90)   ;256 - (posY edf - alt avion) 
        jr nc, crash6
            ;;cosas color vvvvv
                ld b, edf_col_5(ix)
                xor a
                add a, b
                ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q chocarse
                    ld 4(ix), #0xFF
                    ;;GAME OVER
                    ld a, #1
                    ld (_he_muerto), a
            ;;cosas color ^^^^^
            ret
    int2_5:
    ld a, (_pos_avion_x)         
    cp #34
    jr nz, crash6  
        call chq_edf5

    crash6: ; *********************************************************************************************************************
    ld a, (_pos_avion_x)         
    cp #36
    jr nz, int2_6  
        chq_edf6:
        ld a, (_pos_avion_y)
        add a, #(256-100)   ;256 - (posY edf - alt avion) 
        jr nc, crash7
            ;;cosas color vvvvv
                ld b, edf_col_6(ix)
                xor a
                add a, b
                ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q chocarse
                    ld 4(ix), #0xFF
                    ;;GAME OVER
                    ld a, #1
                    ld (_he_muerto), a
            ;;cosas color ^^^^^
            ret
    int2_6:
    ld a, (_pos_avion_x)         
    cp #37
    jr nz, crash7  
        call chq_edf6

    crash7: ; *********************************************************************************************************************
    ld a, (_pos_avion_x)         
    cp #39
    jr nz, int2_7  
        chq_edf7:
        ld a, (_pos_avion_y)
        add a, #(256-125)   ;256 - (posY edf - alt avion) 
        jr nc, sacame_de_aqui
            ;;cosas color vvvvv
                ld b, edf_col_7(ix)
                xor a
                add a, b
                ret z ;;si esto da 0, significa q el edificio ya esta muerto y no hay q chocarse
                    ld 4(ix), #0xFF
                    ;;GAME OVER
                    ld a, #1
                    ld (_he_muerto), a
            ;;cosas color ^^^^^
            ret
    int2_7:
    ld a, (_pos_avion_x)         
    cp #40
    jr nz, sacame_de_aqui  
        call chq_edf7

    sacame_de_aqui:
call entityman_getDinEntityArray_IX
ret

matar_bomba:
    call shotsys_setHayBomba_0 ;;matar a la bomba
    call entityman_getDinEntityArray_IX
    call rendersys_borrar_ult_bomba ;;borrar la bomba
ret
