;;Copyright <2023> <Spaghetti Studios>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.
;
; PHYSICS SYS
.include "cpctelera.h.s"
.include "physics-system.h.s"

.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm
.globl entityman_getNumDinEntities_A
.globl entityman_getEstEntityArray_IX
.globl entityman_getNumEstEntities_A
.globl entityman_getEstEntitySize_BC
.globl shotsys_getHayBomba_A

physicssys_init::
    ;variable pointer prev pos (para el borrado del rastro del jugador)
    _prev_pos_y: .db 0
    _prev_pos_x: .db 0

    ;variable pointer prev pos (para el borrado del rastro de la bomba)
    _prev_pos_y_bmb: .db 0
    _prev_pos_x_bmb: .db 0
ret

physicssys_update::
    call mover_avion_right
    call shotsys_getHayBomba_A
    cp #1
    jr nz, salir  ;cuando NO hay una bomba en pantalla, sale de la funcion
        ;ld din_col(ix), #0xFF ;-> para comprobaciones
        call mover_bomba
        call entityman_getNumDinEntities_A
        ret
    salir:
    call entityman_getNumDinEntities_A
    ret

mover_bomba:
    ;guardamos posicion previa   
    ld a, bomb_x(ix)
    ld (_prev_pos_x_bmb), a

    ld a, bomb_y(ix)
    ld (_prev_pos_y_bmb), a

    ;; mover en y
    ld  a, bomb_y(ix)  
    add bomb_v(ix)     
    ld  bomb_y(ix), a
ret

mover_avion_right:
    ;guardamos posicion previa   
    ld a, e_din_x(ix)
    ld (_prev_pos_x), a

    ld a, e_din_y(ix)
    ld (_prev_pos_y), a

    ;; mover en x
    ld  a, e_din_x(ix)  
    add e_din_v(ix)     
    ld  e_din_x(ix), a 

    add #188  ;;comprobar si me paso por la derecha
    ret nc
        ;bajarlo a la siguiente 'fila' (altura avion -> 10)
        ld a, e_din_y(ix)
        add a, #10
        ld e_din_y(ix), a
        ld e_din_x(ix), #0
ret

physicssys_getPrevPosY_B::
    ld a, (_prev_pos_y)
    ld b, a
    ret

physicssys_getPrevPosX_C::
    ld a, (_prev_pos_x)
    ld c, a
ret

physicssys_getPrevPosYBmb_B::
    ld a, (_prev_pos_y_bmb)
    ld b, a
    ret

physicssys_getPrevPosXBmb_C::
    ld a, (_prev_pos_x_bmb)
    ld c, a
ret