;;Copyright <2023> <Spaghetti Studios>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.
;
;; RENDER SYSTEM
.include "cpctelera.h.s"
.include "render-system.h.s"


.globl cpct_getScreenPtr_asm
.globl cpct_setPalette_asm
.globl cpct_setVideoMode_asm
.globl cpct_drawSolidBox_asm
.globl cpct_drawSprite_asm
.globl entityman_getDinEntitySize_BC
.globl entityman_getEstEntitySize_BC
.globl physicssys_getPrevPosY_B
.globl physicssys_getPrevPosX_C
.globl entityman_getNumDinEntities_A
.globl entityman_getNumEstEntities_A
.globl entityman_getEstEntityArray_IX
.globl entityman_getDinEntityArray_IX
.globl shotsys_getHayBomba_A
.globl physicssys_getPrevPosYBmb_B
.globl physicssys_getPrevPosXBmb_C
.globl _g_palette
.globl _escoba
.globl _bomba
.globl _edificio
.globl _cielo


rendersys_init:: ;======================================================================================
    ld de, #16 
    ld hl, #_g_palette
    call cpct_setPalette_asm
    ld c, #0
    call cpct_setVideoMode_asm 

    cpctm_clearScreen_asm 0x00  

    ret

rendersys_update::
    ; RENDERIZAR ================================================================================================    
    call entityman_getNumEstEntities_A
    call entityman_getEstEntityArray_IX
    call render_est_entities

    call entityman_getNumEstEntities_A
    call entityman_getEstEntityArray_IX
    call render_suelo
    call render_cielo

    call entityman_getDinEntityArray_IX
    call rendersys_borrarprevio_player
    
    call entityman_getNumDinEntities_A 
    call render_player ;;solo el player

    call shotsys_getHayBomba_A
    ; comprobar si es 1 o 0
    cp #1 ;;resta 1 a A
    ret nz  ;nz -> CONDICION PARA IRSE
        ;ld din_col(ix), #0xFF ;-> para comprobaciones
        call rendersys_borrarprevio_bomba
        call render_bomba
    ret

render_cielo::
    ld de, #CPCT_VMEM_START_ASM
    ld b, #0
    ld c, #0
    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl,#_cielo 
    ld c, #20  ;6   ;width
    ld b, #39  ;height
    call cpct_drawSprite_asm

    ld de, #CPCT_VMEM_START_ASM
    ld b, #0
    ld c, #21
    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl,#_cielo 
    ld c, #20  ;6   ;width
    ld b, #39  ;height
    call cpct_drawSprite_asm

    ld de, #CPCT_VMEM_START_ASM
    ld b, #0
    ld c, #41
    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl,#_cielo 
    ld c, #20  ;6   ;width
    ld b, #39  ;height
    call cpct_drawSprite_asm

    ld de, #CPCT_VMEM_START_ASM
    ld b, #0
    ld c, #61
    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl,#_cielo 
    ld c, #20  ;6   ;width
    ld b, #39  ;height
    call cpct_drawSprite_asm
ret

render_bomba:   
    ld de, #CPCT_VMEM_START_ASM
    ld b, bomb_y(ix)
    ld c, bomb_x(ix)
    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl,#_bomba 
    ld c, #3  ;6   ;width
    ld b, bomb_h(ix)  ;height
    call cpct_drawSprite_asm
ret

rendersys_borrarprevio_bomba:
    ;borrar sprite previo SOLO DE LA BOMBA
    ld de, #0xC000
    call physicssys_getPrevPosXBmb_C
    call physicssys_getPrevPosYBmb_B
    call cpct_getScreenPtr_asm
    ex de, hl
    ld a, #0x00      ;color del fondo   
    ld c, bomb_w(ix)    ;width
    ld b, bomb_h(ix)    ;height
    call cpct_drawSolidBox_asm
ret

rendersys_borrar_ult_bomba::
    ;borrar sprite previo SOLO DE LA BOMBA
    ld de, #0xC000
    ld c, bomb_x(ix) 
    ld b, bomb_y(ix) 
    call cpct_getScreenPtr_asm
    ex de, hl
    ld a, #0x00      ;color del fondo   
    ld c, bomb_w(ix)    ;width
    ld b, bomb_h(ix)    ;height
    call cpct_drawSolidBox_asm

    ;ld din_col(ix), #0xFF
ret

rendersys_borrarprevio_player::
    ;borrar sprite previo SOLO DEL JUGADOR
    ld de, #0xC000
    call physicssys_getPrevPosX_C
    call physicssys_getPrevPosY_B
    call cpct_getScreenPtr_asm
    ex de, hl
    ld a, #0x00      ;color del fondo   
    ld c, #12    ;width
    ld b, e_h(ix)    ;height
    call cpct_drawSolidBox_asm
    ret

render_suelo:
    ;preparar los registros para la llamada a cpct_getScreenPtr_asm
    ld de, #0xC000
    ld c, #0               ;carga en c lo que hay en ix + 0
    ld b, #185               ;carga en b lo que hay en ix + 1 (pos en el array)
    call cpct_getScreenPtr_asm  ;consigue la posicion d la esquina sup-izda de la caja

    ;preparar los registros para la llamada a cpct_drawSolidBox_asm
    ex de, hl        ;cambia los contenidos entre sí
    ld a, e_col(ix)  ;color    
    ld c, e_w(ix)    ;width
    ld b, e_h(ix)    ;height
    call cpct_drawSolidBox_asm

    ;preparar los registros para la llamada a cpct_getScreenPtr_asm
    ld de, #0xC000
    ld c, #64               ;carga en c lo que hay en ix + 0
    ld b, #185               ;carga en b lo que hay en ix + 1 (pos en el array)
    call cpct_getScreenPtr_asm  ;consigue la posicion d la esquina sup-izda de la caja

    ;preparar los registros para la llamada a cpct_drawSolidBox_asm
    ex de, hl        ;cambia los contenidos entre sí
    ld a, e_col(ix)  ;color    
    ld c, e_w(ix)    ;width
    ld b, e_h(ix)    ;height
    call cpct_drawSolidBox_asm

    ret

render_player::
 ;   ;preparar los registros para la llamada a cpct_getScreenPtr_asm
 ;   ld de, #0xC000
 ;   ld c, e_x(ix)               ;carga en c lo que hay en ix + 0
 ;   ld b, e_y(ix)               ;carga en b lo que hay en ix + 1 (pos en el array)
 ;   call cpct_getScreenPtr_asm  ;consigue la posicion d la esquina sup-izda de la caja

    ld de, #0xC000
    ld b, e_y(ix)
    ld c, e_x(ix)
    call cpct_getScreenPtr_asm 
    ex de, hl
    ld hl,#_escoba 
    ld c, #12  ;6   ;width
    ld b, #10   ;height
    call cpct_drawSprite_asm

    ret

render_est_entities::
    call entityman_getEstEntityArray_IX
    call entityman_getEstEntitySize_BC
    add ix, bc ;pasar a la siguiente entidad
    call entityman_getEstEntitySize_BC
    add ix, bc ;pasar a la siguiente entidad
    dec a
    dec a
    _est_renloop:
        push af

        ;;borrar previo sprite
        ;ld a, e_x(ix)
        ;ld b, e_y(ix)
        ;ld a, e_h(ix)
        ;call rendersys_borrarprevio_player_est

        ld b, e_col(ix)
        xor a
        add a, b
        jr z, saltar ;;si esto da 0, significa q el edificio ya esta muerto y no hay q derribarlo

        ;preparar los registros para la llamada a cpct_getScreenPtr_asm
        ld de, #0xC000
        ld c, e_x(ix)               ;carga en c lo que hay en ix + 0
        ld b, e_y(ix)               ;carga en b lo que hay en ix + 1 (pos en el array)
        call cpct_getScreenPtr_asm  ;consigue la posicion d la esquina sup-izda de la caja
        ;preparar los registros para la llamada a cpct_drawSolidBox_asm
        ex de, hl        ;cambia los contenidos entre sí
        ld a, e_col(ix)  ;color    
        ld c, e_w(ix)    ;width
        ld b, e_h(ix)    ;height
        call cpct_drawSolidBox_asm

       ; ld de, #0xC000
       ; ld b, e_y(ix)
       ; ld c, e_x(ix)
       ; call cpct_getScreenPtr_asm 
       ; ex de, hl
       ; ld hl,#_edificio 
       ; ld c, #3  ;12   ;width
       ; ld b, e_h(ix)   ;height
       ; call cpct_drawSprite_asm

        saltar:

        pop af

        dec a
        ret z ;salir si no quedan entidades que renderizar

        call entityman_getEstEntitySize_BC
        add ix, bc ;pasar a la siguiente entidad
        jr _est_renloop
    ret