;;Copyright <2023> <Spaghetti Studios>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.
;
;   SHOT SYSTEM
;

.include "cpctelera.h.s"
.include "shot-system.h.s"

.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm

shotsys_init::
    _hay_bomba: .db 0  ;;   0-> no // 1-> si
ret

shotsys_getHayBomba_A::
    ld a, (_hay_bomba)
ret

shotsys_setHayBomba_0::
    ld a, #0
    ld (_hay_bomba), a
ret

shotsys_update::
    call cpct_scanKeyboard_asm
    ld  hl, #Key_Space      
    call  cpct_isKeyPressed_asm   
    jr  z, key_not_pressed   
        ;si se está presionando la tecla:
        ;comprobar si ya hay una bomba en pantalla
        ld a, (_hay_bomba)
        cp #1 ;;resta 1 a A
        ret z  ;cuando SI hay una bomba en pantalla, sale de la funcion
            ;si NO hay una bomba en pantalla:

            ;darle a la bomba la posicion del avion
            ld a, player_x(ix)
            add a, #2       ;;para q caiga desde el principio del avion
            ;ld a, #44
            ld bomb_x(ix), a

            ld a, player_y(ix)
            add a, #10      ;;para q caiga desde debajo del avion
            ld bomb_y(ix), a

            ld a, #1
            ld (_hay_bomba), a

            ;ld player_col(ix), #0xFF

    key_not_pressed:
ret